from base_st_classes import *

## class RenewSuite(NFSSuite):
##     """Test operation 30: RENEW
##     """
##     # FIXME
##     pass

class RenewSuite(NFSSuite):
     """Test operation 30: RENEW
     Equivalence partitioning:

     Input Condition: clientid
         Valid equivalence classes:
             clientid from SETCLIENTID(1)
         Invalid equivalence classes:
             bogus (guessed) clientid (2)
     """

     def testdoOp(self):
          """RENEW with valid clientid

          Covered valid equivalence classes: 1
          """
          self.init_connection()
          res = self.ncl.do_ops([self.ncl.renew()])
          self.assert_OK(res)

     def testdoBadOp(self):
          """RENEW with invalid clientid should return NFS4ERR_STALE_CLIENTID
          
          Covered invalid equivalence classes: 2
          """
          res = self.ncl.do_ops([self.ncl.renew_op(0x1234567812345678)])
          self.assert_status(res, [NFS4ERR_STALE_CLIENTID])

     def testExpired(self):
          """RENEW with expired lease should return NFS4ERR_EXPIRED or OK"""
          # There seems to be no way to force lease to expire, thus the OK
          self.init_connection()
          sleeptime = self.getLeaseTime() * 3 / 2
          self.sleep(sleeptime)
          res = self.ncl.do_ops([self.ncl.renew()])
          self.assert_status(res,[NFS4ERR_EXPIRED, NFS4_OK])
